capture program drop tab4
program define tab4

#delimit;



scalar define bog=1000;
scalar define dev1=bog;
scalar define dev2=bog;
scalar define dev3=bog;
scalar define dev4=bog;
scalar define bug=1;
matrix define mincut=(1000,10000, 20000);
matrix define maxcut=(10e+10,10e+10,10e+10);
scalar define numi=colsof(mincut);
local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;

replace wegtt=min(wagr,caph) if wegtt!=1;
regress dlnwag wdmargt mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10
(wdmargp mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10) [w=wegtt]
if wages/pce>wmin & wages2/pce2>wmin2 & wages/pce<wmax & wages2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(wdmargp)+abs(wdmargt)<bug & marsi==0, robust cluster(id);
savereg wdmargt;

replace wegtt=min(broadnr,caph) if wegtt!=1;
regress dlogbr dmargt  mrs1 mrs2 year79-year88 yz79-yz88
logbr splbro1-splbro10 (dmargp mrs1 mrs2 year79-year88
yz79-yz88  logbr splbro1-splbro10)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtct dmargt  mrs1 mrs2 year79-year88  yzt79-yzt88   logtct
spltct1-spltct10
(dmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtct
spltct1-spltct10 )  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtcp dmargt  mrs1 mrs2 year79-year88  yzt79-yzt88   logtct
spltct1-spltct10
(dmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtct
spltct1-spltct10 )  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtct dmargt  mrs1 mrs2 year79-year88  yzt79-yzt88   logtct
spltct1-spltct10
(dmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtct
spltct1-spltct10 )  [w=wegtt]
if taxct>wmin & taxct2>0*wmin2 & taxct<wmax & taxct2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;


local ii=`ii'+1;
};

log on;
table2a 1 "Mars    -inflat.:num 7 -stat97e,fed0699-
 - weights:     -year lag:" 5 numi "Wage" "Broad"
"Taxable" "Pseudo" "taxable (tax. slices)"
"1K+"  "10K +" "20K+";
savereg, clear;
log off;

end;
